import * as Minecraft from "mojang-minecraft";
const World = Minecraft.World;
const Commands = Minecraft.Commands;


function Execute(txt, dim = "overworld") {
    return Commands.run(String(txt), World.getDimension(dim));
}

function Say(message, player, color = "") {
    Execute(`execute ${player} ~~~ title @s actionbar ${color + String(message)}`);
}

function GetScore(pn, sn) {
    const t = Execute("scoreboard players list " + pn);
    const scores = t.statusMessage.split('-');

    for (let i = 0; i <= scores.length; i++) {
        let s = scores[i];
        if (s.split(":")[0].replace(" ", "") == sn) return parseInt(s.split(":")[1].replace(" ", ""));
    }
    return 0;
}

const structures = ["village", "temple", "stronghold", "shipwreck", "ruinedportal", "pillageroutpost", "ruins", "monument", "mineshaft", "mansion", "buriedtreasure", "bastionremnant", "fortress", "endcity"];
const struct_names = ["Village", "Desert temple - Jungle temple - Igloo - Swamp hut", "Stronghold", "Shipwreck", "Ruined Portal", "Pillager Outpost", "Ocean Ruins", "Underwater Monument", "Mineshaft", "Wooden Mansion", "Buried Treasure", "Bastion Remnant", "Fortress", "End City"];

function Locate(index) {
    let test;
    if (index > 10 && index != 13) {
        test = Execute("locate " + structures[index], "nether");
    } else if (index == 13) {
        test = Execute("locate " + structures[index], "the end");
    } else {
        test = Execute("locate " + structures[index]);
    }

    return [test.destination.z, test.destination.x];
}


function GVA([x1, y1], [x2, y2]) {
    let x = x2 - x1;
    let y = y2 - y1;
    return Math.floor((((Math.acos(y / Math.sqrt(x * x + y * y)) * (Math.sign(x) || 1)) * 180 / Math.PI) + 360) % 360);
}

function WorldTick(data) {
    const ps = World.getPlayers();
    const ct = data.currentTick;
    const tn = parseInt(String(ct).substr(String(ct).length - 1, String(ct).length));
    if (tn != 0) return;
    for (let i = 0; i <= ps.length; i++) {
        let p = ps[i];
        let pl = p.location;
        let css = GetScore(p.name, "css");
        let rtr = RTR(Math.floor(GVA([pl.z, pl.x], Locate(css)) / 11.3), GetScore(p.name, "rot"));

        if (rtr > 31) rtr = rtr - 32;
        if (rtr < 0) rtr = rtr + 32;
        if (p.isSneaking && GetScore(p.name, "equiped_c") == 1) {
            if (css > 12) {
                Execute(`scoreboard players set ${p.name} css 0`);
            } else {
                Execute(`scoreboard players add ${p.name} css 1`);
            }
        }
        if (GetScore(p.name, "equiped_c") == 1) {
            if (css > 10) Say(struct_names[css], p.name, css == 13 ? "§5" : "§4");
            else Say(struct_names[css], p.name, "§f");
            SetCompassRot(p.name, rtr);
        }
    }
}

function RTR(r, r1) {
    if (r1 == 2) {
        return r - 8;
    }
    if (r1 == 3) {
        return r - 24;
    }
    if (r1 == 5) {
        return r - 16;
    }
    return r;
}


function SetCompassRot(p, r) {
    Execute(`replaceitem entity ${p} slot.weapon.mainhand 0 nc:nc_${String(r)}`);
}

World.events.tick.subscribe(WorldTick);